#include <limits.h>

//typedef signed __w64 intptr_t;
const intptr_t INTPTR_MIN = (sizeof(signed __w64) > sizeof(signed __int32) ? _I64_MIN : _I32_MIN);
const intptr_t INTPTR_MAX = (sizeof(signed __w64) > sizeof(signed __int32) ? _I64_MAX : _I32_MAX);

typedef signed __int8 int8_t;
typedef unsigned __int8 uint8_t;
const int8_t INT8_MIN = _I8_MIN;
const int8_t INT8_MAX = _I8_MAX;
const uint8_t UINT8_MAX = _UI8_MAX;

typedef signed __int16 int16_t;
typedef unsigned __int16 uint16_t;
const int16_t INT16_MIN = _I16_MIN;
const int16_t INT16_MAX = _I16_MAX;
const uint16_t UINT16_MAX = _UI16_MAX;

typedef signed __int32 int32_t;
typedef unsigned __int32 uint32_t;
const int32_t INT32_MIN = _I32_MIN;
const int32_t INT32_MAX = _I32_MAX;
const uint32_t UINT32_MAX = _UI32_MAX;

typedef signed __int64 int64_t;
typedef unsigned __int64 uint64_t;
const int64_t INT64_MIN = _I64_MIN;
const int64_t INT64_MAX = _I64_MAX;
const uint64_t UINT64_MAX = _UI64_MAX;
